Ruby - Bug #4854

Invalid locale_charmap (CP0) when running as Windows Service

06/08/2011 04:38 PM - rafal.bigaj (Rafal Bigaj)

Status: Closed

Priority: Normal

Assignee:

Target version: 2.0.0

ruby -v: ruby 1.9.2p136 Backport:
Description

When ruby process is run as Windows Service the console codepage is not set, GetConsoleCP returns 0.

As a result function rb_locale_charmap refers to not existing codepage: CPO.

It has a dramatic performance drawback on the system when for ex. enumerating through ENV.

The attached patch simple checks if the GetConsoleCP() returns 0 and if so uses the actual system codepage.

Associated revisions

Revision c479bde4 - 06/10/2011 07:42 AM - naruse (Yui NARUSE)

¢ encoding.c (rb_locale_charmap): When ruby process is run as Windows
Service the console codepage is not set, GetConsoleCP returns 0.
So on such environment, use GetACP().
http://blogs.msdn.com/b/michkap/archive/2005/02/08/369197.aspx
patched by Rafal Bigaj [ruby-core:36832] [Bug #4854]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@31985 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/10/2011 04:42 PM - naruse (Yui NARUSE)
- Status changed from Open to Closed
- % Done changed from 0 to 100

This issue was solved with changeset r31985.
Rafal, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e encoding.c (rb_locale_charmap): When ruby process is run as Windows
Service the console codepage is not set, GetConsoleCP returns 0.
So on such environment, use GetACP().
http://blogs.msdn.com/b/michkap/archive/2005/02/08/369197.aspx
patched by Rafal Bigaj [ruby-core:36832] [Bug #4854]
